@echo Este Script instalara el cliente de BOINC en su computador
@echo Para mas informacion contactese con scv@ing.udec.cl
@echo Nota: presiona 'Crtl+C' si desea cancelar el procedimiento, o 'Y' para continuar
@pause

@echo off
set NET=%WINDIR%\system32\net
set XCOPY=%WINDIR%\system32\xcopy
set REG=%WINDIR%\system32\reg

:: Paths
set LOGSSHARE=C:
set LOG=%LOGSSHARE%\%COMPUTERNAME%-%USERNAME%.log
set BOINCINSTALLLOG=%LOGSSHARE%\%COMPUTERNAME%-%USERNAME%-BOINC.log
set BOINCINSTALLER=boinc_windows_intelx86.exe

::check for install files - acct_mgr_url.xml
IF NOT EXIST acct_mgr_url.xml (
echo.
echo El archivo acct_mgr_url.xml no se encuentra,  favor de guardar una copia del archivo en este directorio y volver a intentarlo.
echo.
pause
GOTO endscript
) 

::check for install files - acct_mgr_login.xml
IF NOT EXIST acct_mgr_login.xml (
echo.
echo El archivo acct_mgr_login.xml no se encuentra, favor de guardar una copia del archivo en este directorio y volver a intentarlo.
echo.
pause
GOTO endscript
) 

::check for install files - BOINC Executable
IF NOT EXIST %BOINCINSTALLER% (
echo.
echo El archivo %BOINCINSTALLER% no se encuentra, favor de guardar una copia reciente del instalador con ese nombre y volver a intentarlo.
echo.
pause
GOTO endscript
) 

:: Install BOINC
echo Installing BOINC (%BOINCINSTALLER%) >> %LOG% 
%BOINCINSTALLER% /v"REBOOT=ReallySupress /passive ENABLESCREENSAVER=0 ENABLEPROTECTEDAPPLICATIONEXECUTION2=1 /l*v %BOINCINSTALLLOG% "

:: Configure BOINC
::@set CONFIGURATION=LOGSHARE
::@if defined ProgramData set BOINC="C:\BOINC"
::@if not defined ProgramData set BOINC="C:\BOINC"
::%XCOPY% /I /Y %CONFIGURATION%\cc_config.xml %BOINC% >> %LOG% 2>&1

:: Remove BOINC Shortcuts.
rmdir "%USERPROFILE%\Men Inicio\Programas\BOINC" /S /Q
::rmdir "%APPDATA%\Microsoft\Windows\Men Inicio\Programas\BOINC" /S /Q

:: Disable BOINC manager startup.
reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Run" /v boincmgr /f
:: Delete BOINC manager
del "%PROGRAMFILES%\BOINC\boincmgr.exe" /Q
copy /Y "acct_mgr_login.xml" "%allusersprofile%\Datos de programa\BOINC"
copy /Y "acct_mgr_url.xml" "%allusersprofile%\Datos de programa\BOINC"
:: Start BOINC.%
::echo Starting BOINC Service ... >> %LOG%
%NET% start BOINC
::echo Starting BOINC Tray ... >> %LOG%
::start "" "C:\Program Files\BOINC\boinctray.exe"
echo Listo.

:endscript
